{--------------------------------------------------
Hi !
You're able to use parts of this source code by
mention of my name.
Please report any bugs/comments to yoda_f2f@gmx.net.
Have fun !
--------------------------------------------------}
unit Unit1;   {$IMAGEBASE $0f2f0000} 
                                                                                     
interface

uses
  Windows, SysUtils, Controls, Forms, ExtCtrls, math, StdCtrls, Classes, Dialogs,pelib,
  Menus,clipbrd,psapi,tlhelp32;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Edit1: TEdit;
    Memo1: TMemo;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    PopupMenu1: TPopupMenu;
    copytoclipboard1: TMenuItem;
    copypaste1: TMenuItem;
    selectall1: TMenuItem;
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure copytoclipboard1Click(Sender: TObject);
    procedure selectall1Click(Sender: TObject);
    procedure copypaste1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

const ver       : string  = '1.1';
      compiled  : string  = '8/2/00';
      tmpfile   : string  = 'DFX_TMP.bin';
      trademark : string  = '[DumpFX 1.1] by yoda -=[f2f]=-';
      calc      : integer = 1000;
      yodastamp : dword   = $61646f79;
      packerEP  : dword   = $63e80;
var
  Form1                 : TForm1;
  comparts              : array [1..5] of string;
  rambytes              : array [1..16] of char;
  searchbytes           : array [1..50] of char;
  charp                 : ^char;
  bytep                 : char;
  i,ii,iii,found        : longint;
  RAM                   : boolean;
  Ramsize               : longint;
  maph,fileh            : thandle;
  mempoi,tmppoi,poi     : pointer;
  tmpsize,tmpnum,tmpnum2: dword;
  many                  : cardinal;
  savefile, loadfile    : file of char;
  count,attrib          : integer;
  mapfile,patchbyte     : string;
  fixit                 : boolean;
  outfile               : TmemoryStream; // oh I love it ;)
  currentproc           : byte;
  // PE fun variables
  dosh                  : PIMAGE_DOS_HEADER;
  peh                   : PIMAGE_NT_HEADERS;
  sectionh              : PIMAGE_SECTION_HEADER;
  // task variables
  pid                   : array [1..100] of cardinal;
  processnames          : array [1..100] of string;
  modulenames           : array [1..150] of string;
  modbase               : array [1..150] of longint;
  modsize               : array [1..150] of longint;
  mid                   : array [1..150] of dword;
  tasktype              : byte;
  wd                    : pchar;
  // ...for win nt/2k
  ph                   : thandle;
  mh                   : array [1..150] of thandle;
  pointr               : pointer;
  modinfos             : lpMODULEINFO;
  // ...for win 9x
  modu                 : TModuleEntry32;
  proc                 : TProcessEntry32;
  what,what2           : Integer;
  mhandle,snap,snap2   : THandle;
  size                 : array [1..100] of Cardinal;
  base                 : array [1..100] of PByte;
  gotprocs,gotmods     : boolean;
  // counter
  nop,nom              : integer;

implementation

{$R *.DFM}

function checknum(stri : string):boolean;
begin
result:=true;
for count:=1 to length(stri) do
 if (stri[count] < '0') or (stri[count] > '9') then result:=false;
end;

function GetWinDir: string;
var
  wdir: PChar;
begin
  wdir := StrAlloc(256);
  GetWindowsDirectory(wdir, 255);
  GetWinDir := StrPas(wdir) + '\';
end;

function checkhexnum(stri : string):boolean;
begin
result:=true;
for count:=1 to length(stri) do
 if ((stri[count] < '0') or (stri[count] > '9')) and ((stri[count] < 'A') or (stri[count] > 'F')) then
 result:=false;
end;

function hex2int (hexdigit : string):dword;
var  i,m: integer;
     zw : extended;
     t,n: longint;
     hextmp : string;
     intdigit : dword;
begin
for i:=length(hexdigit) downto 1 do hextmp:=hextmp+hexdigit[i];
intdigit:=0;
for i:=length(hextmp)downto 1 do
 begin
  case upcase(hextmp[i]) of
   'A' : m:=10;
   'B' : m:=11;
   'C' : m:=12;
   'D' : m:=13;
   'E' : m:=14;
   'F' : m:=15;
   else
   m:=strtoint(hextmp[i]);
   end;
   zw:=intpower(16,i-1);
   n:=trunc(zw);
   t:=m*n;
   intdigit:=intdigit+t;
   end;
result:=intdigit;
end;

function showhex(charvalue : char): string;
begin
result:=inttohex(ord(charvalue),2)
end;

procedure d(stri:string);
begin
form1.memo1.lines.add(stri);
end;

procedure unknown;
begin
d('unknown command :(');
end;

procedure bad;
begin
d('command incomplete !');
end;

procedure checkattr;
begin
attrib:=filegetattr(form1.opendialog1.filename);
   if attrib and fareadonly <> 0 then
    begin
    filesetattr(form1.opendialog1.filename,attrib-fareadonly);
    d('readonly attribute deleted !');
    end;
end;

procedure unmap;
begin
virtualunlock(mempoi,ramsize*calc);
flushviewoffile(mempoi,0);
UnMapViewOfFile(mempoi);
closehandle(maph);
closehandle(fileh);
ram:=false;
end;

procedure raminfo;
begin
if ram = false then
 begin
 d('no RAM allocated !');
 exit;
 end;
d('Current mapping file:');
d(mapfile);
d('Startaddress of the allocated RAM: '+ inttohex(cardinal(mempoi),8));
d('Endaddress of allocated RAM:       '+ inttohex(cardinal(mempoi)+ramsize*calc,8));
d('Size in bytes - dec: '+inttostr(ramsize*calc)+ ' hex: '+inttohex(ramsize*calc,8));
end;

procedure fillram;
begin
if ram = false then
 begin
 d('no ram allocated !');
 exit;
 end;
if comparts[2] = '' then
 begin
 bad;
 exit;
 end;
if (checkhexnum(comparts[2]) = false) or (length(comparts[2]) > 2) then
 begin
 d('invalid fillcharacter !');
 exit;
 end;
tmppoi:=mempoi;
tmpsize:=ramsize*calc;
if comparts[3] <> '' then
 begin
 if checkhexnum(comparts[3]) = false then // check the size
  begin
  d('invalid size !');
  exit;
  end;
 if hex2int(comparts[3]) > ramsize*calc then
  begin
  d('size is to big !');
  exit;
  end;
 tmpsize:=hex2int(comparts[3]);
 if comparts[4] <> '' then               // check the startoffset
  begin
  if checkhexnum(comparts[4]) = false then
   begin
   d('invalid startoffset !');
   exit;
   end;
  if (hex2int(comparts[4]) < cardinal(mempoi)) or
  ( (hex2int(comparts[4])+tmpsize) > cardinal(mempoi)+ramsize*calc ) then
   begin
   d('out of range !');
   exit;
   end;
  inc(cardinal(tmppoi),hex2int(comparts[4])-cardinal(mempoi));
  end;
 end;
fillmemory(tmppoi,tmpsize,hex2int(comparts[2]));       // fill area
d('target memory successfully filled with '+(comparts[2]));
end;

procedure loadpart;
begin
if ram = false then
 begin
 d('no RAM allocated !');
 exit;
 end;
// load the whole file
if comparts[2] = '' then
 begin
 if form1.opendialog1.execute then
  begin
  checkattr;
  assignfile(loadfile,form1.opendialog1.filename);
   {$I-}
   reset(loadfile);
   {$I+}
   if IOResult <> 0 then
    begin
    d('error opening file ! seems to be in use...');
    exit;
    end;
  tmpsize:=filesize(loadfile)-1;
  if tmpsize > ramsize*calc then
   begin
   d('filesize to big ! I take only '+inttohex(ramsize*calc,8)+'h bytes...');
   tmpsize:=ramsize*calc;
   end;
  blockread(loadfile,mempoi^,tmpsize);
  end    // of with opendialog...
  else
  begin
  d('no file selected ! aborting...');
  exit;
  end;
 end;
// load with custom size (, custom startoffset)
if comparts[2] <> '' then
begin
 if checkhexnum(comparts[2]) = false then
  begin
  d('invalid size !');
  exit;
  end;
 tmpsize:=hex2int(comparts[2]);
 if tmpsize > ramsize*calc then
  begin
  d('size is to big !');
  exit;
  end;
 if form1.opendialog1.execute then
 begin
  checkattr;
  assignfile(loadfile,form1.opendialog1.filename);
  {$I-}
  reset(loadfile);
  {$I+}
  if IOResult <> 0 then
   begin
   d('error opening file ! seems to by in use...');
   exit;
   end;
  if filesize(loadfile)-1 < tmpsize then
   begin
   d('the file is to small ! I take only '+inttohex(filesize(loadfile)-1,8)+'h bytes...');
   tmpsize:=filesize(loadfile)-1;
   end;
  tmppoi:=mempoi;
  // copy all to a custom startoffset ?
  if comparts[3] <> '' then
   begin
   if checkhexnum(comparts[3]) = false then
    begin
    d('invalid startoffset !');
    exit;
    end;
   tmpnum:=hex2int(comparts[3]);
   if (tmpnum < cardinal(mempoi)) or ((cardinal(mempoi)+ramsize*calc) < (tmpnum+tmpsize)) then
    begin
    d('invalid startoffset !');
    exit;
    end;
   inc(cardinal(tmppoi),tmpnum-cardinal(mempoi));
   end;
  blockread(loadfile,tmppoi^,tmpsize);
end // of with opendialog...
else
 begin
 d('no file selected ! aborting...');
 exit;
 end;
end;
// show result
d(inttohex(tmpsize,8)+'h bytes successfully copied from '+extractfilename(form1.opendialog1.filename)+
  ' to '+inttohex(cardinal(tmppoi),8)+' !');
closefile(loadfile);
end;

procedure writepart;
begin
if ram = false then
 begin
 d('no RAM allocated !');
 exit;
 end;
form1.savedialog1.filename:='dumped.dmp';
// dump the whole file
if comparts[2] = '' then
 begin
 if form1.savedialog1.execute then
   begin
   assignfile(savefile,form1.savedialog1.filename);
   {$I-}
   rewrite(savefile);
   {$I+}
   if IOResult <> 0 then
    begin
    d('error creating file !');
    exit;
    end;
   blockwrite(savefile,mempoi^,ramsize*calc);
   end
   else // no file selected
    begin
    d('no file selected ! aborting...');
    exit;
    end;
 d(extractfilename(form1.savedialog1.filename)+' successfully created with '+inttostr(ramsize*calc)+' bytes :)');
 closefile(savefile);
 exit;
 end;
if checkhexnum(comparts[2]) = false then
 begin
 d('invalid size !');
 exit;
 end;
tmpsize:=hex2int(comparts[2]);
 // standart startoffset
 if comparts[3]='' then
  begin
  if (tmpsize = 0) or (tmpsize > ramsize*calc) then
   begin
   d('invalid size !');
   exit;
   end;
  if form1.savedialog1.execute then
   begin
   assignfile(savefile,form1.savedialog1.filename);
   {$I-}
   rewrite(savefile);
   {$I+}
   if IOResult <> 0 then
    begin
    d('error creating file !');
    exit;
    end;
   blockwrite(savefile,mempoi^,tmpsize);
   end
   else // no file selected
    begin
    d('no file selected ! aborting...');
    exit;
    end;
  end
  else
  // custom startoffset
  begin
  if checkhexnum(comparts[3]) = false then
   begin
   d('invalid startoffset !');
   exit;
   end;
  tmpnum:=hex2int(comparts[3]);
  if (tmpnum < cardinal(mempoi)) or ((cardinal(mempoi)+ramsize*calc) < (tmpnum+tmpsize)) then
   begin
   d('invalid startoffset !');
   exit;
   end;
  if form1.savedialog1.execute then
   begin
   assignfile(savefile,form1.savedialog1.filename);
   {$I-}
   rewrite(savefile);
   {$I+}
   if IOResult <> 0 then
    begin
    d('error creating file !');
    exit;
    end;
   tmppoi:=mempoi;
   inc(cardinal(tmppoi),tmpnum-cardinal(mempoi));
   blockwrite(savefile,tmppoi^,tmpsize);
   end
   else // no file selected
    begin
    d('no file selected ! aborting...');
    exit;
    end;
  end;
// show result
d(extractfilename(form1.savedialog1.filename)+' successfully created with '+inttostr(tmpsize)+' bytes :)');
closefile(savefile);
end;

procedure patch;
begin
// some checking
if ram = false then
 begin
 d('no ram allocated !');
 exit;
 end;
if comparts[2] = '' then
 begin
 bad;
 exit;
 end;
if checkhexnum(comparts[2]) = false then
 begin
 d('invalid patch bytes !');
 exit;
 end;
if frac(length(comparts[2])/2) <> 0 then
 begin
 d('invalid patch bytes !');
 exit;
 end
else
 tmpsize:= length(comparts[2]) div 2;
tmppoi:=mempoi;
// a custom patch offset ?
if comparts[3] <> '' then
 begin
 if checkhexnum(comparts[3]) = false then
  begin
  d('invalid startoffset !');
  exit;
  end;
 if (hex2int(comparts[3]) < cardinal(mempoi)) or
    ((hex2int(comparts[3])+tmpsize) > (ramsize*calc)+cardinal(mempoi)) then
  begin
  d('invalid startoffset !');
  exit;
  end;
 inc(cardinal(tmppoi),hex2int(comparts[3])-cardinal(mempoi));
 end;
// start patching
for i:=1 to tmpsize do
 begin
 charp:=tmppoi;
 patchbyte:=comparts[2][i*2-1]+comparts[2][i*2];
 charp^:=chr(hex2int(patchbyte));
 //display details
 d(inttohex(cardinal(tmppoi),8)+' patched with '+patchbyte+' !');
 inc(cardinal(tmppoi));
 end;
// done.
end;

procedure search;
begin
// some checking...
if ram = false then
 begin
 d('no ram allocated !');
 exit;
 end;
if comparts[2] = '' then
 begin
 bad;
 exit;
 end;
if checkhexnum(comparts[2]) = false then
 begin
 d('invalid search bytes !');
 exit;
 end;
if frac(length(comparts[2])/2) <> 0 then
 begin
 d('invalid search bytes !');
 exit;
 end
else
 tmpsize:= length(comparts[2]) div 2;
if tmpsize > 50 then
 begin
 d('the maximum number of bytes is 50 !');
 exit;
 end;
tmppoi:=mempoi;
if comparts[3] <> '' then // get a custom startoffset for searching
 begin
 if checkhexnum(comparts[3]) = false then
  begin
  d('invalid from-value !');
  exit;
  end;
 if (hex2int(comparts[3]) < cardinal(mempoi)) or
    (hex2int(comparts[3]) > (cardinal(mempoi)+ramsize*calc)) then
  begin
  d('invalid from-value !');
  exit;
  end;
 tmppoi:=pointer(hex2int(comparts[3]));
 end;
ii:=ramsize*calc;
if comparts[4] <> '' then // get a custom endoffset for searching
 begin
 if checkhexnum(comparts[4]) = false then
  begin
  d('invalid to-value !');
  exit;
  end;
 if (hex2int(comparts[4]) < cardinal(mempoi)) or
    (hex2int(comparts[4]) > (cardinal(mempoi)+ramsize*calc)) then
  begin
  d('invalid to-value !');
  exit;
  end;
 ii := hex2int(comparts[4])-cardinal(tmppoi);
 if ii <= 0 then
  begin
  d('the to-value must be bigger then the from-value !');
  exit;
  end;
 end;
charp:=tmppoi;
// put the bytes into an array
for i:=1 to tmpsize do
searchbytes[i]:=chr(hex2int(comparts[2][i*2-1]+comparts[2][i*2]));
// start searching
count:=1;
found:=0;
for i:=1 to ii do
begin
bytep:=charp^;
if searchbytes[count] = bytep  then inc(count)
                               else count:=1;
if count > tmpsize then // sth found !
 begin
 d('pattern found at '+inttohex(cardinal(charp)-tmpsize+1,8));
 inc(found);
 count:=1;
 if found = 200 then
  begin
  d('the pattern was now found 200 times ! aborting...');
  d('please enter more bytes !');
  exit;
  end;
 end;
inc(charp);
end;
//show result
d(comparts[2]+' was found '+inttostr(found)+' time(s) !');
end;

procedure displayram;
var charstr : string;
begin
if ram = false then
 begin
 d('no RAM allocated !');
 exit;
 end;
tmppoi:=mempoi;
// custom display position ?
if comparts[2] <> '' then
 if checkhexnum(comparts[2]) = false then
  begin
  d('invalid position !');
  exit;
  end
  else
   if (hex2int(comparts[2]) < cardinal(mempoi)) or
      (hex2int(comparts[2]) > (ramsize*calc+cardinal(mempoi))) then
   begin
   d('position out of range !');
   exit;
   end
   else
   inc(cardinal(tmppoi),hex2int(comparts[2])-cardinal(mempoi));
charp:=tmppoi;
tmpnum:=cardinal(tmppoi);
for ii:=1 to 17 do // number of lines
begin
// get 16 bytes
for i:=1 to 16 do
 begin
 rambytes[i]:=charp^;
 inc(charp);
 end;
// make the charstring
charstr:='';
for i:=1 to 16 do
 begin
 if rambytes[i] = #0 then begin;
                          charstr:=charstr+'.';
                          continue;
                          end;
 if rambytes[i] < #21 then begin
                           charstr:=charstr+' ';
                           continue;
                           end;
 charstr:=charstr+rambytes[i];
 end;
// show it
d(inttohex(tmpnum,8)+'  '+
  showhex(rambytes[1])+' '+showhex(rambytes[2])+' '+showhex(rambytes[3])+' '+showhex(rambytes[4])+' '+
  showhex(rambytes[5])+' '+showhex(rambytes[6])+' '+showhex(rambytes[8])+' '+showhex(rambytes[9])+' '+
  showhex(rambytes[10])+' '+showhex(rambytes[11])+' '+showhex(rambytes[12])+' '+showhex(rambytes[13])+' '+
  showhex(rambytes[14])+' '+showhex(rambytes[15])+' '+showhex(rambytes[16])+'  '+charstr);
inc(tmpnum,16);
end; // of the for ... to lines loop
end;

procedure getram;
begin
if ram then
 begin
 d('RAM allready allocated ! use the N command...');
 exit;
 end;
if (comparts[2] =' ') or (comparts[2] = '') then
 begin
 bad;
 exit;
 end;
if checknum(comparts[2]) = false then
 begin;
 d('invalid size !');
 exit;
 end;
ramsize:=strtoint(comparts[2]);
// some other test
if ramsize = 0 then
 begin
 d('a size of 0 isn''t allowed !');
 exit;
 end;
if ramsize > 10000 then
 begin
 d('the maximum size is 10 MB !');
 exit;
 end;
mapfile:=getwindir+'TEMP\'+tmpfile;
// create the file
fileh:=Createfilea(pchar(mapfile),GENERIC_READ+GENERIC_WRITE,FILE_SHARE_WRITE,nil,CREATE_ALWAYS,0,0);
 if fileh=INVALID_HANDLE_VALUE then
  begin
   d('creation of '+tmpfile+' failed !');
   exit;
  end;
 maph:=Createfilemapping(fileh,nil,PAGE_READWRITE+sec_commit,0,ramsize*calc,nil);
  if maph=0 then
   begin
    d('creation of '+tmpfile+' failed !');
    closehandle(fileh);
    exit;
   end;
// get the mempointer of the file
  mempoi:=MapViewOfFile(maph,FILE_MAP_write,0,0,0);
  if mempoi=nil then
   begin
    d('creation of '+tmpfile+' failed !');
    closehandle(maph);
    closehandle(fileh);
    exit;
   end;
fillmemory(mempoi,ramsize*calc,0);
strcopy(mempoi,pchar(trademark));
Virtuallock(mempoi,ramsize*calc); //protect the allocated RAM
ram:=true;
raminfo;
end;

procedure getramex;
begin
if ram then
 begin
 unmap;
 d(mapfile+' closed !');
 d('');
 end;
if (comparts[2] =' ') or (comparts[2] = '') then
 begin
 bad;
 exit;
 end;
if checknum(comparts[2]) = false then
 begin
 d('invalid size !');
 exit;
 end;
ramsize:=strtoint(comparts[2]);
if ramsize = 0 then
 begin
 d('a size of 0 isn''t allowed !');
 exit;
 end;
if ramsize > 10000 then
 begin
 d('the maximum size is 10 MB !');
 exit;
 end;
form1.savedialog1.filename:='DFX_TMP1.bin';
if form1.savedialog1.Execute then
 begin
 // create the file
 fileh:=Createfilea(pchar(form1.savedialog1.filename),GENERIC_READ+GENERIC_WRITE,FILE_SHARE_WRITE,nil,CREATE_ALWAYS,0,0);
 if fileh=INVALID_HANDLE_VALUE then
  begin
   d('Creation of '+extractfilename(form1.savedialog1.filename)+' failed !');
   exit;
  end;
  maph:=Createfilemapping(fileh,nil,PAGE_READWRITE+sec_commit,0,ramsize*calc,nil);
  if maph=0 then
   begin
    d('Creation of '+extractfilename(form1.savedialog1.filename)+' failed !');
    closehandle(fileh);
    exit;
   end;
  // get the mempointer of the file
  mempoi:=MapViewOfFile(maph,FILE_MAP_write,0,0,0);
  if mempoi=nil then
   begin
    d('Creation of '+extractfilename(form1.savedialog1.filename)+' failed !');
    closehandle(maph);
    closehandle(fileh);
    exit;
   end;
 fillmemory(mempoi,ramsize*calc,0);
 strcopy(mempoi,pchar(trademark));
 virtuallock(mempoi,ramsize*calc); //protect the RAM
 mapfile:=form1.savedialog1.filename;
 ram:=true;
 raminfo;
 end
 else
 begin
 d('no file selected ! aborting...');
 exit;
 end;
end;

procedure unmapfile;
begin
if ram then
 begin
 unmap;
 d(mapfile+' closed !');
 end
 else
 d('no ram allocated !');
end;

procedure dumpwin;
var wh,ph,pid   : integer;
    many        : cardinal;
begin
if ((comparts[2] = '') or (comparts[3] = '')) or (comparts[4] = '') then
 begin
 bad;
 exit;
 end;
if checkhexnum(comparts[4]) = false then      //check the size
 begin
 d('invalid size !');
 exit;
 end;
tmpsize:=hex2int(comparts[4]);
if checkhexnum(comparts[3]) = false then     // check the ramaddr
 begin
 d('invalid startoffset !');
 exit;
 end;
tmpnum:=hex2int(comparts[3]);
wh:=findwindowex(0,0,0,pchar(comparts[2]));  // get the window handel
if wh = 0 then
 begin
 d('window not found :( aborting...');
 exit;
 end;
getwindowthreadprocessid(wh,@pid);  // get its process id
if pid = 0 then
 begin
 d('can''t get the process ID :( aborting...');
 closehandle(wh);
 exit;
 end;
ph:=OpenProcess(PROCESS_VM_READ,false,pid);   // get the process handle
if ph=0 then
 begin
 d('can''t find out the process handle ! aborting...');
 closehandle(wh);
 exit;
 end;
poi:=allocmem(tmpsize);
if ReadProcessMemory(ph,pbyte(tmpnum),poi,tmpsize,many)= false then  // read it into the mem
 begin
 d('can''t read process memory :(');
 exit;
 end;
form1.savedialog1.filename:='dumped.dmp';
if form1.savedialog1.execute then   // ... and write it into a file
 begin
 assignfile(savefile,form1.savedialog1.filename);
 {$I-}
 rewrite(savefile);
 {$I+}
 if IOResult <> 0 then
    begin
    d('error creating file !');
    exit;
    end;
 blockwrite(savefile,poi^,tmpsize);
 closefile(savefile);
 d(extractfilename(form1.savedialog1.filename)+' successfully created with '+inttostr(tmpsize)+' bytes :)');
 end
 else
 d('no file selected ! aborting...');
freemem(poi);    // ok ok her's the user's RAM back
closehandle(ph);
end;

function gettasktype : byte;    // return values:  0 - win 9x   1 - win nt/2k
begin
result:=0;
snap:=CreateToolhelp32Snapshot(TH32CS_SNApprocess,0);
proc.dwsize:=sizeof(proc);
Process32First(snap,proc) ;
if extractfilename(proc.szExeFile) = proc.szexefile then
 result:=1;
end;

procedure getbasesize;
begin
pointr:=allocmem(sizeof(MODULEINFO));
modinfos:=pointr;
if getmoduleinformation(ph,mh[1],modinfos,sizeof(MODULEINFO)) = true then
    begin
    size[i]:=modinfos.SizeOfImage;
    base[i]:=pbyte(cardinal(modinfos.lpBaseOfDll));
    end;
freemem(pointr);
end;

procedure getmodbasesize;
begin
pointr:=allocmem(sizeof(MODULEINFO));
modinfos:=pointr;
if getmoduleinformation(ph,mh[i],modinfos,sizeof(MODULEINFO)) = true then
    begin
    modsize[i]:=modinfos.SizeOfImage;
    modbase[i]:=cardinal(modinfos.lpBaseOfDll);
    mid[i]:=cardinal(modinfos.EntryPoint);
    end;
freemem(pointr);
end;

procedure getmodules(what : integer);
begin
gotmods:=true;
case tasktype of
  0:    // win 9x
  begin
  snap:=CreateToolhelp32Snapshot(TH32CS_SNAPModule,pid[what]);
  modu.dwsize:=sizeof(modu);
  module32first(snap,modu);
  modulenames[1]:=modu.szExePath;
  mid[i]:=modu.th32ModuleID;
  modbase[1]:=cardinal(modu.modBaseAddr);
  modsize[1]:=cardinal(modu.modBaseSize);
   nom:=1;
   for  i:=2 to 150 do
   begin
   if module32next(snap,modu) = false then break;
   modulenames[i]:=modu.szExePath;
   mid[i]:=modu.th32ModuleID;
   modbase[i]:=cardinal(modu.modBaseAddr);
   modsize[i]:=cardinal(modu.modBaseSize);
   inc(nom);
   end;
   closehandle(snap);
   end; // of win9x
  1:begin
    ph:=openprocess(PROCESS_VM_READ+PROCESS_QUERY_INFORMATION,true,pid[what]);
    // clear the mh array
     for iii:=1 to 150 do
     mh[iii]:=0;
    // get all modulehandles
    enumprocessmodules(ph,@mh,sizeof(mh),tmpnum2);
    i:=1;
    nom:=0;
    while mh[i] <> 0 do
     begin
     getmodbasesize;
     getmodulefilenameex(ph,mh[i],wd,max_path-1);
     modulenames[i]:=wd;
     inc(i);
     inc(nom);
     end;
    // show all
    end;
  end; // of case ... of
end;

procedure getprocesses;
begin
gotprocs:=true;
// check the OS
tasktype:=gettasktype;
case tasktype of
0:
begin         //win 9x
// get all processes
nop:=1;
snap:=CreateToolhelp32Snapshot(TH32CS_SNApprocess,0);
proc.dwsize:=sizeof(proc);
Process32First(snap,proc) ;
pid[1]:=proc.th32processid;
processnames[1]:=proc.szExeFile;

for i:=2 to 100 do
begin
 if Process32Next(snap,proc)=false then break;
 inc(nop);
 pid[i]:=proc.th32processid;
 processnames[i]:=proc.szExeFile;
end;
closehandle(snap);

// get size and address of the processes
 for i:=1 to nop do begin
 size[i]:=0;base[i]:=nil;
 snap2:=CreateToolhelp32Snapshot(TH32CS_SNAPModule,pid[i]);
 modu.dwsize:=sizeof(modu);
 Module32First(snap2,modu);
 if modu.szExePath=processnames[i] then begin
 size[i]:=modu.modBaseSize;
 base[i]:=modu.modBaseAddr;
 closehandle(snap2);
 end;
 
 for iii:=1 to 100 do
  begin
 if Module32Next(snap2,modu)=false then break;
 if modu.szExePath=processnames[i] then  begin
 size[i]:=modu.modBaseSize;
 base[i]:=modu.modBaseAddr;
 closehandle(snap2);
 end;
 end;
 end;
end; // end of case 0
1:begin
  // start
  wd := StrAlloc(256);
  // delete pid array
  for i:=1 to 100 do
  pid[i]:=0;
  enumprocesses(@pid,sizeof(pid),tmpnum);
  for i:=1 to 100 do
   begin
   ph:=openprocess(PROCESS_VM_READ+PROCESS_QUERY_INFORMATION,true,pid[i]);
    case i of
    1: begin
       processnames[i]:='[ System Idle Process ]';
       size[i]:=0; base[i]:=0;
       continue;
       end;
    end; //  of case i
   // delete the mh array
   for iii:=1 to 150 do
   mh[iii]:=0;
   enumprocessmodules(ph,@mh,sizeof(mh),tmpnum2);
   if mh[1] = 0 then // a system process !
    begin
    processnames[i]:='[ System ]';
    size[i]:=0; base[i]:=0;
    continue;
    end;
   // get the process name
   getmodulefilenameex(ph,mh[1],wd,max_path-1);
   processnames[i]:=wd;
   // get size of image and the imagebase
   getbasesize;
  end;
  // count the processnumber
  nop:=1;
  for i:=2 to 100 do
   if pid[i] <> 0 then inc(nop);
  closehandle(ph);
  end; // end of case 1
end; // of case of construction
////////////////////////////////////////////////////
end;

procedure showtasks;
begin
getprocesses;
for i:=1 to nop do
d(inttostr(i)+' - '+processnames[i]);
end;

procedure showmodules;
begin
if comparts[2] = '' then
 begin
 bad;
 exit;
 end;
if gotprocs=false then getprocesses;
if checknum(comparts[2]) = false then
 begin
 d('invalid number !');
 exit;
 end;
if strtoint(comparts[2]) > nop then
 begin
 d('there are only '+inttostr(nop)+' processes running !');
 exit
 end;
getmodules(strtoint(comparts[2]));
currentproc:=strtoint(comparts[2]);
if nom = 0 then
 begin
 d('this process has no modules !');
 exit;
 end;
for i:=1 to nom do
d(inttostr(i)+' - '+modulenames[i]);
end;

procedure kill;
begin
if (comparts[2] = '') or (comparts[3] = '') then
 begin
 bad;
 exit;
 end;
// kill a process
if comparts[2] = 'P' then
 begin
 if checknum(comparts[3]) = false then
  begin
  d('the third parameter is invalid !');
  exit;
  end;
 if gotprocs = false then getprocesses;
 ph:=openprocess(PROCESS_TERMINATE,true,pid[strtoint(comparts[3])]);
 if terminateprocess(ph,0) = false then
  begin
  d('error on terminating process !');
  closehandle(ph);
  exit;
  end;
 closehandle(ph);
 d(extractfilename(processnames[strtoint(comparts[3])])+' was killed successfully !');
 sleep(200);
 exit;
 end;
// free a module
if comparts[2] = 'M' then
 begin
 if checknum(comparts[3]) = false then
  begin
  d('the third parameter is invalid !');
  exit;
  end;
 tmpnum:=strtoint(comparts[3]);
 if modulenames[tmpnum] = processnames[currentproc] then
  begin
  d('the target module is a process ! kill it through the process list...');
  exit;
  end;
 if gotmods = false then
  begin
  d('you have to view a module list before killing !');
  exit;
  end;
 if tasktype = 0 then
 mhandle:=getmodulehandle(pchar(modulenames[tmpnum]))
 else
 mhandle:=mh[tmpnum];
if freelibrary(mhandle)=false then
 begin
 d('error on freeing library !');
 exit;
 end;
 d(extractfilename(modulenames[tmpnum])+' was killed successfully !');
 sleep(200);
 exit;
 end;
d('the second parameter is invalid !');
end;

procedure fix;
begin
if form1.opendialog1.execute then
 begin
 checkattr;
 // load the file into the ram
 outfile:=tmemorystream.create;
 outfile.LoadFromFile(form1.opendialog1.filename);
 // get some useful infos
 dosh := PIMAGE_DOS_HEADER(outfile.memory);
 peh:= PIMAGE_NT_HEADERS(Longword(dosh) + Longword(dosh.e_lfanew));
 sectionh:=PIMAGE_SECTION_HEADER(peh);
 // check whether it's a valid PE file
 if (dosh.e_magic <> IMAGE_DOS_SIGNATURE) or (peh.Signature <> IMAGE_NT_SIGNATURE) then
  begin
  d('invalid PE file ! aborting...');
  outfile.free;
  exit;
  end;
 // start of fix
 inc(PIMAGE_NT_HEADERS(sectionh));
 for i:=1 to peh.FileHeader.NumberOfSections do
  begin
  sectionh.SizeOfRawData:=    sectionh.PhysicalAddress;
  sectionh.PointerToRawData:= sectionh.VirtualAddress;
  inc(sectionh);
  end;
 // done
 // set trademark :)
 peh.FileHeader.TimeDateStamp:=yodastamp;
 // save changes if not in use
 outfile.SaveToFile(form1.opendialog1.filename);
 d('dumpfix successfully applied to '+extractfilename(form1.opendialog1.filename)+' !');
 end
 else
 d('no file selected ! aborting...');
end;

procedure fixex( filename : string);
begin
 // load the file into the ram
 outfile:=tmemorystream.create;
 outfile.LoadFromFile(filename);
 // get some useful infos
 dosh := PIMAGE_DOS_HEADER(outfile.memory);
 peh:= PIMAGE_NT_HEADERS(Longword(dosh) + Longword(dosh.e_lfanew));
 sectionh:=PIMAGE_SECTION_HEADER(peh);
 // check whether it's a valid PE file
 if (dosh.e_magic <> IMAGE_DOS_SIGNATURE) or (peh.Signature <> IMAGE_NT_SIGNATURE) then
  begin
  d('invalid PE file ! dumpfix canceled...');
  outfile.free;
  exit;
  end;
 // start of fix
 inc(PIMAGE_NT_HEADERS(sectionh));
 for i:=1 to peh.FileHeader.NumberOfSections do
  begin
  sectionh.SizeOfRawData:=    sectionh.PhysicalAddress;
  sectionh.PointerToRawData:= sectionh.VirtualAddress;
  inc(sectionh);
  end;
 // done
 // set trademark :)
 peh.FileHeader.TimeDateStamp:=yodastamp;
 // save changes if not in use
 outfile.SaveToFile(filename);
end;

procedure dumpprocess;
begin
fixit:=true;
// some checks
if gotprocs = false then getprocesses;
if comparts[2] = '' then
 begin
 bad;
 exit;
 end;
if checknum(comparts[2]) = false then
 begin
 d('invalid process number !');
 exit
 end;
tmpnum2:=strtoint(comparts[2]);
if nop < tmpnum2 then
 begin
 d('there are only '+inttostr(nop)+' processes running !');
 exit;
 end;
if (cardinal(base[tmpnum2])=0) or (size[tmpnum2]=0) then
 begin
 d('I''m unable to dump this process :(');
 exit;
 end;
// a custom size ?
tmpsize:=size[tmpnum2];
tmpnum:=cardinal(base[tmpnum2]);
form1.savedialog1.filename:='dumped'+extractfileext(processnames[tmpnum2]);
if comparts[3] <> '' then
 begin
 fixit:=false;
 form1.savedialog1.filename:='dumped.dmp';
 if checkhexnum(comparts[3]) = false then
  begin
  d('invalid size !');
  exit;
  end;
 if hex2int(comparts[3]) > tmpsize then
  begin
  d('the size can''t be bigger than the SizeofImage('+inttohex(tmpsize,8)+') !');
  exit;
  end;
 tmpsize:=hex2int(comparts[3]);
 // a custom startoff ?
 tmpnum:=cardinal(base[tmpnum2]);
 if comparts[4] <> '' then
  begin
  if checkhexnum(comparts[4]) = false then
   begin
   d('invalid startoffset !');
   exit;
   end;
  if (hex2int(comparts[4]) < tmpnum) or (hex2int(comparts[4]) > tmpnum+tmpsize) then
   begin
   d('startoffset is out of range ! (Imagebase: '+inttohex(tmpnum,8)+')');
   exit;
   end;
  tmpnum:=hex2int(comparts[4]);
  end;
 end;
// Start
with form1.savedialog1 do
if execute then
 begin
 ph:=openprocess(PROCESS_VM_READ,true,pid[tmpnum2]);
 poi:=allocmem(tmpsize);
 if ReadProcessMemory(ph,pointer(tmpnum),poi,tmpsize,many) = false then
  begin;
  d('error while reading memory !');
  freemem(poi);
  closehandle(ph);
  exit;
  end;
 assignfile(savefile,form1.savedialog1.filename);
 {$I-}
 rewrite(savefile);
 {$I+}
 if ioresult <> 0 then
   begin
   d('error creating file !');
   exit;
   end;
 blockwrite(savefile,poi^,tmpsize);
// Done
 closehandle(ph);
 closefile(savefile);
 sleep(50);
 // fix the sections
 if fixit then fixex(form1.savedialog1.filename);
 freemem(poi);
 d(extractfilename(processnames[tmpnum2])+' successfully dumped :)');
 end // of with savedialog1....
else
d('no file selected ! aborting...');
end;

procedure dumpmodule;
begin
fixit:=true;
// some checks
if gotmods = false then
 begin
 d('you have to view a module list before a module dump !');
 exit;
 end;
if comparts[2] = '' then
 begin
 bad;
 exit;
 end;
if checknum(comparts[2]) = false then
 begin
 d('invalid module number !');
 exit
 end;
tmpnum2:=strtoint(comparts[2]);
if modulenames[tmpnum2] = processnames[currentproc] then
 begin
 d('the target module is a process ! dump it through the process list...');
 exit;
 end; 
if nom < tmpnum2 then
 begin
 d('the current process has only '+inttostr(nop)+' modules !');
 exit;
 end;
if (modbase[tmpnum2]=0) or (modsize[tmpnum2]=0) then
 begin
 d('I''m unable to dump this module :(');
 exit;
 end;
// a custom size ?
tmpsize:=modsize[tmpnum2];
tmpnum:=modbase[tmpnum2];
form1.savedialog1.filename:='dumped'+extractfileext(modulenames[tmpnum2]);
if comparts[3] <> '' then
 begin
 fixit:=false;
 form1.savedialog1.filename:='dumped.dmp';
 if checkhexnum(comparts[3]) = false then
  begin
  d('invalid size !');
  exit;
  end;
 if hex2int(comparts[3]) > tmpsize then
  begin
  d('the size can''t be bigger than the SizeofImage('+inttohex(tmpsize,8)+') !');
  exit;
  end;
 tmpsize:=hex2int(comparts[3]);
 // a custom startoff ?
 if comparts[4] <> '' then
  begin
  if checkhexnum(comparts[4]) = false then
   begin
   d('invalid startoffset !');
   exit;
   end;
  if (hex2int(comparts[4]) < tmpnum) or (hex2int(comparts[4]) > tmpnum+tmpsize) then
   begin
   d('startoffset is out of range ! (Imagebase: '+inttohex(tmpnum,8)+')');
   exit;
   end;
  tmpnum:=hex2int(comparts[4]);
  end;
 end;
// Start
if form1.SaveDialog1.Execute then
 begin
  poi:=allocmem(tmpsize);
  ph:=OpenProcess(PROCESS_VM_READ,true,pid[currentproc]);
  if readprocessmemory(ph,pointer(tmpnum),poi,tmpsize,many) = false then
   begin;
   d('error while reading memory !');
   freemem(poi);
   closehandle(ph);
   exit;
   end;
  assignfile(savefile,form1.savedialog1.FileName);
  {$I-}
  rewrite(savefile);
  {$I+}
  if ioresult <> 0 then
   begin
   d('Error creating file !');
   exit;
   end;
  blockwrite(savefile,poi^,tmpsize);
  // Done.
  closefile(savefile);
 // fix the sections
 if fixit then fixex(form1.savedialog1.filename);
 freemem(poi);
 closehandle(PH);
 d(extractfilename(modulenames[tmpnum2])+' successfully dumped :)');
 end // if savedialog1....
else
d('no file selected ! aborting...');
end;

procedure about;
begin
d('');
d('                     ------------------------                  ');
d('                            DumpFX '+ver+'                     ');
d('                     ------------------------                  ');
d('                                        by yoda                ');
d('                                                               ');
d('                        compiled: '+compiled);
d('');
d('           DumpFX is a (I hope) easy to use memory dumper.     ');
d('         It can mainly be used with debuggers like Softice.    ');
d('       You can''t blame me for any damage caused through DumpFX.');
d('        Please report any bugs or comments to yoda_f2f@gmx.net ');
d('');
d('');
d('                         Have (dumping) fun !                 ');
d('                                                               ');
end;

procedure h;
begin
if comparts[2] = '' then
 begin
 d('please choose a command !');
 exit;
 end;
if comparts[2] = 'C' then
 begin
 d('Syntax: C');
 d('This command shows all available commands.');
 exit;
 end;
if comparts[2] = 'A' then
 begin
 d('Syntax: A [size]');
 d('size:   must be a decimal number');
 d('        is limited to 10000 (10MB)');
 d('This command creates a mapping file (windir\temp\'+tmpfile+') with [size] kilobyte.');
 d('The R command will be executed automatically.');
 exit;
 end;
if comparts[2] = 'N' then
 begin
 d('Syntax: N [size]');
 d('size:   must be a decimal number');
 d('        is limited to 10000 (10MB)');
 d('This command lets you choose a custom mapping file through a savedialog.');
 d('The selected mapping file would be created with [size] kilobyte.');
 d('The R command will be executed automatically.');
 exit;
 end;
if comparts[2] = 'R' then
 begin
 d('Syntax: R');
 d('Displays the path of the mapping file, startoffset, endoffset and size (dec and hex) of the allocated memory.');
 exit;
 end;
if comparts[2] = 'F' then
 begin
 d('Syntax: F [chr] (size) (startoff)');
 d('chr:      must be a hex ASCII number');
 d('          specifies a character, e.g.: CC');
 d('size:     specifies the size (in hex) to fill');
 d('startoff: is a hex value between startoffset and endoffset');
 d('This command sets (size) bytes from (startoff) to [chr].');
 d('If no startoff was entered then DumpFX will fill from the start of the allocated memory on.');
 d('If no size and no startoff were entered then the whole allocated memory will be filled with [chr].');
 exit;
 end;
if comparts[2] = 'L' then
 begin
 d('Syntax: L (size) (startoff)');
 d('size:     is a hex number');
 d('startoff: is a hex value between startoffset and endoffset');
 d('This command lets you choose a file through a opendialog and loads (size) bytes from the selected file to (startoff).');
 d('If no startoff was entered then the file will be loaded to the start of the allocated memory.');
 d('If no size and no startoff were entered then the whole file will be loaded into the allocated memory.');
 exit;
 end;
if comparts[2] = 'W' then
 begin
 d('Syntax: W (size) (startoff)');
 d('size:     is a hex number');
 d('startoff: is a hex value between startoffset and endoffset');
 d('This command lets you choose a file through a savedialog and writes (size) bytes from (startoff) to the selected file.');
 d('If no startoff was entered then the bytes from the start of the allocated memory will be written to the new file.');
 d('If no size and no startoff were entered then the whole allocated memory will be written to the selected file.');
 exit;
 end;
if comparts[2] = 'P' then
 begin
 d('Syntax: P [bytes] (startoff)');
 d('bytes:    is a string of hex bytes, e.g.: EB00');
 d('startoff: is a hex value between startoffset and endoffset');
 d('This command writes [bytes] to (startoff).');
 d('If no startoff was entered then DumpFX patches from the start of the allocated memory on.');
 exit;
 end;
if comparts[2] = 'S' then
 begin
 d('Syntax: S [bytes] (from) (to)');
 d('bytes: is a string of hex bytes, e.g.: EB00');
 d('from:  is a hex value between startoffset and endoffset');
 d('to:    is also a hex value between startoffset and endoffset');
 d('This command searches for [bytes] from (from) to (to) and lists all');
 d('locations matching with the pattern.');
 d('If no to-value was entered then DumpFX will search for the bytes from');
 d('the from-value to endoffset.');
 d('If no from and no to values were entered then DumpFX will search in');
 d('the whole memory.');
 exit;
 end;
if comparts[2] = 'D' then
 begin
 d('Syntax: D (pos)');
 d('pos:    is a hex value between startoffset and endoffset');
 d('This command displays the allocated memory at (pos).');
 d('If no pos-value was entered then the memory at startoffset will');
 d('be displayed.');
 exit;
 end;
if comparts[2] = 'UNMAP' then
 begin
 d('Syntax: UNMAP');
 d('This command unmaps the current mapping file.');
 exit;
 end;
if comparts[2] = 'FIX' then
 begin
 d('Syntax: FIX');
 d('This command lets you choose a file through a opendialog.');
 d('All Rawoffsets will be fixed to their corresponding Virtualoffsets and all Rawsizes will be fixed to their corresponding Virtualsizes.');
 d('This fix is e.g. needed if a file has been purely dumped from memory.');
 exit;
 end;
if comparts[2] = 'ABOUT' then
 begin
 d('Syntax: ABOUT');
 d('This command displays some uninteresting infos about DumpFX.');
 exit;
 end;
if comparts[2] = 'CLS' then
 begin
 d('Syntax: CLS');
 d('This clears the textfield.');
 exit;
 end;
if comparts[2] = 'H' then
 begin
 d(':P');
 d('Syntax: H [command]');
 d('command: is one of the commands seen through "C"');
 d('This command explains a command more in detail.');
 exit;
 end;
if comparts[2] ='Q' then
 begin
 d('Syntax: Q');
 d('This command unmaps the current mapping file and exits the proggy.');
 exit;
 end;
if comparts[2] = 'DW' then
 begin
 d('Syntax: DW [wintitle] [startoff] [size]');
 d('wintitile: is the title of a window');
 d('startoff:  is a VA pointing into the memory of the');
 d('           process owning the window');
 d('size:      a hex value');
 d('This command dumps [size] bytes from [startoff] of the process');
 d('which owns a window with the title [wintitile].');
 d('You have to put the wintitile into quotes if there''s space in it.');
 exit;
 end;
// puh!... that was a lot
if comparts[2] = 'T' then
 begin
 d('Syntax: T');
 d('This command shows a list of the paths of all running processes.');
 d('It works on win 9x/nt/2k.');
 exit;
 end;
if comparts[2] = 'M' then
 begin
 d('Syntax: M [num]');
 d('This command shows all modules of the [num]. process.');
 exit;
 end;
if comparts[2] = 'DP' then
 begin
 d('Syntax: DP [num] (size) (startoff)');
 d('num:      number of the target process');
 d('size:     a hex number');
 d('startoff: is a VA pointing into the memory of the target process');
 d('This command let you select a file through a savedialog and dumps (size)');
 d('bytes from (startoff) of the [num]. process.');
 d('If no startoff was entered then DumpFX will dump from the start of the');
 d('memory of the target process.');
 d('If no size and no startoff were entered then the whole process will be');
 d('dumped and the FIX command will be executed automatically.');
 exit;
 end;
if comparts[2] = 'DM' then
 begin
 d('Syntax: DM [num] (size) (startoff)');
 d('num:      number of the target module');
 d('size:     a hex number');
 d('startoff: is a VA pointing into the memory of the target module');
 d('This command let you select a file through a savedialog and dumps (size)');
 d('bytes from (startoff) of the [num]. module.');
 d('If no startoff was entered then DumpFX will dump from the start of the');
 d('memory of the target module.');
 d('If no size and no startoff were entered then the whole module will be');
 d('dumped and the FIX command will be executed automatically.');
 exit;
 end;
if comparts[2] = 'K' then
 begin
 d('Syntax: K [P/M] [num]');
 d('P/M:  is either P (process) or M (module)');
 d('num:  number of the target module/process');
 d('This command kills the [num]. process/module.');
 exit;
 end;
unknown;
end;

procedure getcommands; // displays all available commands
begin
d('Commands:                  []=must be entered ()=optionally');
d(' C                         - shows this');
d(' A [size]                  - get size kilobytes of memory');
d(' N [size]                  - creates a new custom mapping file');
d(' R                         - shows infos about allocated memory');
d(' F [chr] (size) (startoff) - fills size/the whole memory with a character');
d(' L (size) (startoff)       - loades size bytes/all from a file');
d(' W (size) (startoff)       - writes size bytes/all to a new file');
d(' P [bytes] (startoff)      - patches the target memory with bytes');
d(' S [bytes] (from) (to)     - searches in the target memory for bytes');
d(' D (pos)                   - displays memory');
d(' UNMAP                     - closes the current mapping file');
d(' FIX                       - fixes sections of a dump PE file');
d(' ABOUT                     - shows infos about this proggy');
d(' CLS                       - clears this textfield');
d(' H [command]               - displays a help more in detail');
d(' Q                         - unmapping & quiet');
d('Other dumpers:');
d(' DW [wintitle] [startoff] [size] - dump a process through its windowtitle');
d(' T                               - shows all running tasks');
d(' M [num]                         - shows all modules of a process');
d(' DP [num] (size) (startoff)      - dumps a task');
d(' DM [num] (size) (startoff)      - dumps a module');
d(' K [P/M] [num]                   - kills a process/module');
end;

procedure getmeaning;
begin
form1.edit1.text:='';
d('');
// recognize the command
if comparts[1] = 'CLS'   then begin form1.memo1.lines.clear;  exit; end;
if comparts[1] = 'C'     then begin getcommands;              exit; end;
if comparts[1] = 'A'     then begin getram;                   exit; end;
if comparts[1] = 'N'     then begin getramex;                 exit; end;
if comparts[1] = 'R'     then begin raminfo;                  exit; end;
if comparts[1] = 'F'     then begin fillram;                  exit; end;
if comparts[1] = 'L'     then begin loadpart;                 exit; end;
if comparts[1] = 'W'     then begin writepart;                exit; end;
if comparts[1] = 'P'     then begin patch;                    exit; end;
if comparts[1] = 'S'     then begin search;                   exit; end;
if comparts[1] = 'D'     then begin displayRAM;               exit; end;
if comparts[1] = 'UNMAP' then begin unmapfile;                exit; end;
if comparts[1] = 'FIX'   then begin fix;                      exit; end;
if comparts[1] = 'ABOUT' then begin about;                    exit; end;
if comparts[1] = 'H'     then begin h;                        exit; end;
if comparts[1] = 'Q'     then begin form1.Close;              exit; end;
if comparts[1] = 'DW'    then begin dumpwin;                  exit; end;
if comparts[1] = 'T'     then begin showtasks;                exit; end;
if comparts[1] = 'M'     then begin showmodules;              exit; end;
if comparts[1] = 'DP'    then begin dumpprocess;              exit; end;
if comparts[1] = 'DM'    then begin dumpmodule;               exit; end;
if comparts[1] = 'K'     then begin kill;                     exit; end;
unknown;
end;

procedure getcommand;
var pos : integer;
label done;
begin
pos:=1;
for i:=1 to 5 do
comparts[i]:='';
for i:=1 to 5 do
 begin
  // wipe space
  while (form1.edit1.text[pos] = ' ') do
   inc(pos);
  // get the string
  if form1.edit1.text[pos] ='"' then     // a string in quotes
   begin
   inc(pos);
    while form1.edit1.text[pos] <> '"' do
    begin
    comparts[i]:=comparts[i]+form1.edit1.text[pos];
     if pos >= length(form1.edit1.text) then goto done;
    inc(pos);
    end;
   end
   else
  while (form1.edit1.text[pos] <> ' ') and (form1.edit1.text[pos] <> '') do  // a normal string
   begin
   comparts[i]:=comparts[i]+form1.edit1.text[pos];
    if pos >= length(form1.edit1.text) then goto done;
   inc(pos);
   end;
 inc(pos);
 end;
// now we have all commandparts in the "comparts" - array
done:
getmeaning;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
if edit1.text <> '' then
 if key=chr($d) then getcommand;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
// intialize ram variable
ram      := false;
gotprocs := false;
// show commands
getcommands;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if ram then
unmap;
end;
procedure TForm1.PopupMenu1Popup(Sender: TObject);
begin
copytoclipboard1.enabled:=memo1.sellength > 0;
copypaste1.enabled:=copytoclipboard1.enabled;
end;

procedure TForm1.copytoclipboard1Click(Sender: TObject);
begin
memo1.CopyToClipboard;
end;

procedure TForm1.selectall1Click(Sender: TObject);
begin
memo1.SetFocus;
memo1.SelectAll;
end;

procedure TForm1.copypaste1Click(Sender: TObject);
begin
memo1.CopyToClipboard;
edit1.text:=edit1.text+clipboard.AsText;
end;

end.
